package dev.lazyfury.paybox;

import java.util.HashMap;
import java.util.Map;

import android.text.TextUtils;

import com.alibaba.fastjson.JSON;

public class PayResult {
	private String resultStatus;
	private String result;
	private String memo;
	public  PayResult(String result,String resultStatus,String memo){
		this.resultStatus = resultStatus;
		this.result = result;
		this.memo = memo;
	}
	public PayResult(Map<String, String> rawResult) {
		if (rawResult == null) {
			return;
		}

		for (String key : rawResult.keySet()) {
			if (TextUtils.equals(key, "resultStatus")) {
				resultStatus = rawResult.get(key);
			} else if (TextUtils.equals(key, "result")) {
				result = rawResult.get(key);
			} else if (TextUtils.equals(key, "memo")) {
				memo = rawResult.get(key);
			}
		}
	}

	public HashMap<String,String> toMap(){
		HashMap<String ,String> map = new HashMap<String, String>();
		map.put("result",result==null?"":result);
		map.put("resultStatus",resultStatus==null?"":resultStatus);
		map.put("memo",memo==null?"":memo);
		return map;
	}


	@Override
	public String toString() {
		return JSON.toJSONString(this);
	}



	/**
	 * @return the resultStatus
	 */
	public String getResultStatus() {
		return resultStatus;
	}

	/**
	 * @return the memo
	 */
	public String getMemo() {
		return memo;
	}

	/**
	 * @return the result
	 */
	public String getResult() {
		return result;
	}
}
